/*
 * Cell Broadband Engine Performance Monitor
 *
 * (C) Copyright IBM Corporation 2001,2006
 *
 * Author: David Erb (djerb@us.ibm.com)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __PERFMON_H__
#define __PERFMON_H__

#define NR_PHYS_CTRS		4

typedef enum {
	group_control,
	debug_bus_control,
	pm_control,
	pm_interval,
	pm_start_stop
} pm_reg_name;

extern void set_cbe_ctr_size(u32 cpu, u32 phys_ctr, u32 ctr_size);
extern u32  get_cbe_ctr_size(u32 cpu, u32 phys_ctr);

extern u32  cbe_read_phys_ctr(u32 cpu, u32 phys_ctr);
extern u32  cbe_read_ctr(u32 cpu, u32 ctr);
extern void cbe_write_phys_ctr(u32 cpu, u32 phys_ctr, u32 val);
extern void cbe_write_ctr(u32 cpu, u32 ctr, u32 val);

extern void cbe_enable_pm_interrupts(u32 cpu, u32 thread, u32 mask);
extern void cbe_disable_pm_interrupts(u32 cpu);
extern u32  cbe_query_pm_interrupts(u32 cpu);
extern u32  cbe_clear_pm_interrupts(u32 cpu);

extern void cbe_enable_pm(u32 cpu);
extern void cbe_disable_pm(u32 cpu);

extern void cbe_write_pm (u32 cpu, pm_reg_name reg, u32 val);
extern void cbe_write_pm07_control(u32 cpu, u32 ctr, u32 val);
extern u32  cbe_read_pm (u32 cpu, pm_reg_name reg);
extern u32  cbe_read_pm07_control(u32 cpu, u32 ctr);

#endif
